(***********************************************************************)
(*                                                                     *)
(*                              Ref-image                              *)
(*                                                                     *)
(*                  Image Segmentation by Refinement                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2009-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.2+dev0 generated code. *)

let printer_element pp_a ctx ppf = function
  | a_u_k -> Uindex_hashtbl_print.printer_key pp_a ctx ppf a_u_k
;;

let printer_index pp_a ctx ppf = function
  | a_u_v -> Uindex_hashtbl_print.printer_value pp_a ctx ppf a_u_v
;;

let printer_t pp_a ctx ppf = function
  | { Uindex_universe.tables = a_u_t; Uindex_universe.cardinal = u_l; } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,@[<hv 2>tables =";
    Uindex_hashtbl_print.printer_t pp_a
      Og_precedence.Ck_record_field
      ppf
      a_u_t;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>cardinal =";
    Upervasives_print.printer_length Og_precedence.Ck_record_field ppf u_l;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

(* Defining top printers. *)

let print_element pp_a ppf =
  printer_element pp_a Og_precedence.Ck_toplevel ppf
;;

let print_index pp_a ppf = printer_index pp_a Og_precedence.Ck_toplevel ppf
;;

let print_t pp_a ppf = printer_t pp_a Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.2+dev0 generated code. *)
