(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.2+dev0 generated code. *)

let rec printer_t pp_a ctx ppf = function
  | { Uaref.get = f_u_a; Uaref.set = f_a_u; } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,@[<hv 2>get =";
    Og_printer.printer_Fun Og_printer.printer_Unit pp_a
      Og_precedence.Ck_record_field
      ppf
      f_u_a;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>set =";
    Og_printer.printer_Fun pp_a Og_printer.printer_Unit
      Og_precedence.Ck_record_field
      ppf
      f_a_u;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_aref pp_a ctx ppf = function | a_t -> printer_t pp_a ctx ppf a_t
;;

let printer_aref_list pp_a ctx ppf = function
  | {
      Uaref.get_list = f_u_a_l;
      Uaref.add_item = f_a_u;
      Uaref.clear_list = f_u_u;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,@[<hv 2>get_list =";
    Og_printer.printer_Fun
      Og_printer.printer_Unit
      (Og_printer.printer_List pp_a)
      Og_precedence.Ck_record_field
      ppf
      f_u_a_l;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>add_item =";
    Og_printer.printer_Fun pp_a Og_printer.printer_Unit
      Og_precedence.Ck_record_field
      ppf
      f_a_u;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>clear_list =";
    Og_printer.printer_Fun Og_printer.printer_Unit Og_printer.printer_Unit
      Og_precedence.Ck_record_field
      ppf
      f_u_u;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let printer_aref_name ctx ppf = function
  | s -> Og_printer.printer_String ctx ppf s
;;

let printer_aref_spec _pp_a _pp_b ctx ppf = function
  | a -> Og_printer.printer_Abstract ctx ppf a
;;

let printer_bounds_spec pp_b ctx ppf = function
  | {
      Uaref.min = b_o;
      Uaref.max = b_o0;
      Uaref.compare = f_b_f_b_i;
      Uaref.string_of = f_b_s;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,@[<hv 2>min =";
    Og_printer.printer_Option pp_b Og_precedence.Ck_record_field ppf b_o;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>max =";
    Og_printer.printer_Option pp_b Og_precedence.Ck_record_field ppf b_o0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>compare =";
    Og_printer.printer_Fun
      pp_b
      (Og_printer.printer_Fun pp_b Og_printer.printer_Int)
      Og_precedence.Ck_record_field
      ppf
      f_b_f_b_i;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>string_of =";
    Og_printer.printer_Fun pp_b Og_printer.printer_String
      Og_precedence.Ck_record_field
      ppf
      f_b_s;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let printer_flag ctx ppf = function
  | {
      Uaref.get_flag = f_u_b;
      Uaref.set_flag = f_u_u;
      Uaref.unset_flag = f_u_u0;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,@[<hv 2>get_flag =";
    Og_printer.printer_Fun Og_printer.printer_Unit Og_printer.printer_Bool
      Og_precedence.Ck_record_field
      ppf
      f_u_b;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>set_flag =";
    Og_printer.printer_Fun Og_printer.printer_Unit Og_printer.printer_Unit
      Og_precedence.Ck_record_field
      ppf
      f_u_u;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>unset_flag =";
    Og_printer.printer_Fun Og_printer.printer_Unit Og_printer.printer_Unit
      Og_precedence.Ck_record_field
      ppf
      f_u_u0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let printer_tflag ctx ppf = function
  | { Uaref.get_tflag = f_u_b; Uaref.toggle_tflag = f_u_u; } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,@[<hv 2>get_tflag =";
    Og_printer.printer_Fun Og_printer.printer_Unit Og_printer.printer_Bool
      Og_precedence.Ck_record_field
      ppf
      f_u_b;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>toggle_tflag =";
    Og_printer.printer_Fun Og_printer.printer_Unit Og_printer.printer_Unit
      Og_precedence.Ck_record_field
      ppf
      f_u_u;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

(* Defining top printers. *)

let print_t pp_a ppf = printer_t pp_a Og_precedence.Ck_toplevel ppf

and print_aref pp_a ppf = printer_aref pp_a Og_precedence.Ck_toplevel ppf
;;

let print_aref_list pp_a ppf =
  printer_aref_list pp_a Og_precedence.Ck_toplevel ppf
;;

let print_aref_name ppf = printer_aref_name Og_precedence.Ck_toplevel ppf
;;

let print_aref_spec pp_a pp_b ppf =
  printer_aref_spec pp_a pp_b Og_precedence.Ck_toplevel ppf
;;

let print_bounds_spec pp_b ppf =
  printer_bounds_spec pp_b Og_precedence.Ck_toplevel ppf
;;

let print_flag ppf = printer_flag Og_precedence.Ck_toplevel ppf
;;

let print_tflag ppf = printer_tflag Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.2+dev0 generated code. *)
