(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.2+dev0 generated code. *)

let printer_t pp_a ctx ppf = function
  | a_a -> Og_printer.printer_Array pp_a ctx ppf a_a
;;

let printer_length ctx ppf = function
  | u_l -> Upervasives_print.printer_length ctx ppf u_l

and printer_index ctx ppf = function
  | u_i -> Upervasives_print.printer_index ctx ppf u_i

and printer_offset ctx ppf = function
  | u_o -> Upervasives_print.printer_offset ctx ppf u_o
;;

let printer_init_rec1 pp_a ctx ppf = function | a -> pp_a ctx ppf a

and printer_prev_rec1 pp_a ctx ppf = function | a -> pp_a ctx ppf a
;;

let printer_scheme_rec1_lin pp_a ctx ppf = function | a -> pp_a ctx ppf a
;;

let printer_prod_scal1 pp_a ctx ppf = function
  | f_a_s_f_a_p_a ->
    Og_printer.printer_Fun
      (printer_scheme_rec1_lin pp_a)
      (Og_printer.printer_Fun (printer_prev_rec1 pp_a) pp_a)
      ctx
      ppf
      f_a_s_f_a_p_a
;;

let printer_init_rec2 pp_a ctx ppf = function
  | (a, a0) ->
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ "
      else
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_tuple_item then
      Format.fprintf ppf "%,@[<hv 2>(@,";
    Format.fprintf ppf "%,@[<hv 0>"; pp_a Og_precedence.Ck_tuple_item ppf a;
    Format.fprintf ppf "%,,@ "; pp_a Og_precedence.Ck_tuple_item ppf a0;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
      else
    if ctx = Og_precedence.Ck_tuple_item then
      Format.fprintf ppf "%,@;<0 -2>)@]"

and printer_prev_rec2 pp_a ctx ppf = function
  | (a, a0) ->
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ "
      else
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_tuple_item then
      Format.fprintf ppf "%,@[<hv 2>(@,";
    Format.fprintf ppf "%,@[<hv 0>"; pp_a Og_precedence.Ck_tuple_item ppf a;
    Format.fprintf ppf "%,,@ "; pp_a Og_precedence.Ck_tuple_item ppf a0;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
      else
    if ctx = Og_precedence.Ck_tuple_item then
      Format.fprintf ppf "%,@;<0 -2>)@]"
;;

let printer_scheme_rec2_lin pp_a ctx ppf = function
  | (a, a0) ->
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ "
      else
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_tuple_item then
      Format.fprintf ppf "%,@[<hv 2>(@,";
    Format.fprintf ppf "%,@[<hv 0>"; pp_a Og_precedence.Ck_tuple_item ppf a;
    Format.fprintf ppf "%,,@ "; pp_a Og_precedence.Ck_tuple_item ppf a0;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
      else
    if ctx = Og_precedence.Ck_tuple_item then
      Format.fprintf ppf "%,@;<0 -2>)@]"
;;

let printer_prod_scal2 pp_a ctx ppf = function
  | f_a_s_f_a_p_a ->
    Og_printer.printer_Fun
      (printer_scheme_rec2_lin pp_a)
      (Og_printer.printer_Fun (printer_prev_rec2 pp_a) pp_a)
      ctx
      ppf
      f_a_s_f_a_p_a
;;

let printer_index_min ctx ppf = function | i -> printer_index ctx ppf i

and printer_index_max ctx ppf = function | i -> printer_index ctx ppf i
;;

(* Defining top printers. *)

let print_t pp_a ppf = printer_t pp_a Og_precedence.Ck_toplevel ppf
;;

let print_length ppf = printer_length Og_precedence.Ck_toplevel ppf

and print_index ppf = printer_index Og_precedence.Ck_toplevel ppf

and print_offset ppf = printer_offset Og_precedence.Ck_toplevel ppf
;;

let print_init_rec1 pp_a ppf =
  printer_init_rec1 pp_a Og_precedence.Ck_toplevel ppf

and print_prev_rec1 pp_a ppf =
  printer_prev_rec1 pp_a Og_precedence.Ck_toplevel ppf
;;

let print_scheme_rec1_lin pp_a ppf =
  printer_scheme_rec1_lin pp_a Og_precedence.Ck_toplevel ppf
;;

let print_prod_scal1 pp_a ppf =
  printer_prod_scal1 pp_a Og_precedence.Ck_toplevel ppf
;;

let print_init_rec2 pp_a ppf =
  printer_init_rec2 pp_a Og_precedence.Ck_toplevel ppf

and print_prev_rec2 pp_a ppf =
  printer_prev_rec2 pp_a Og_precedence.Ck_toplevel ppf
;;

let print_scheme_rec2_lin pp_a ppf =
  printer_scheme_rec2_lin pp_a Og_precedence.Ck_toplevel ppf
;;

let print_prod_scal2 pp_a ppf =
  printer_prod_scal2 pp_a Og_precedence.Ck_toplevel ppf
;;

let print_index_min ppf = printer_index_min Og_precedence.Ck_toplevel ppf

and print_index_max ppf = printer_index_max Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.2+dev0 generated code. *)
