(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.2+dev0 generated code. *)

let printer_xml_t px_a ctx ppf = function
  | a_a -> Og_printer_xml.printer_xml_Array px_a ctx ppf a_a
;;

let printer_xml_length ctx ppf = function
  | u_l -> Upervasives_print_xml.printer_xml_length ctx ppf u_l

and printer_xml_index ctx ppf = function
  | u_i -> Upervasives_print_xml.printer_xml_index ctx ppf u_i

and printer_xml_offset ctx ppf = function
  | u_o -> Upervasives_print_xml.printer_xml_offset ctx ppf u_o
;;

let printer_xml_init_rec1 px_a ctx ppf = function | a -> px_a ctx ppf a

and printer_xml_prev_rec1 px_a ctx ppf = function | a -> px_a ctx ppf a
;;

let printer_xml_scheme_rec1_lin px_a ctx ppf = function | a -> px_a ctx ppf a
;;

let printer_xml_prod_scal1 px_a ctx ppf = function
  | f_a_s_f_a_p_a ->
    Og_printer_xml.printer_xml_Fun
      (printer_xml_scheme_rec1_lin px_a)
      (Og_printer_xml.printer_xml_Fun (printer_xml_prev_rec1 px_a) px_a)
      ctx
      ppf
      f_a_s_f_a_p_a
;;

let printer_xml_init_rec2 px_a ctx ppf = function
  | (a, a0) ->
    ignore ctx; Format.fprintf ppf "%,@[<hv 2><tuple>@,";
    px_a Og_precedence.Ck_tuple_item ppf a; Format.fprintf ppf "%,@,";
    px_a Og_precedence.Ck_tuple_item ppf a0;
    Format.fprintf ppf "%,@;<0 -2></tuple>@]"

and printer_xml_prev_rec2 px_a ctx ppf = function
  | (a, a0) ->
    ignore ctx; Format.fprintf ppf "%,@[<hv 2><tuple>@,";
    px_a Og_precedence.Ck_tuple_item ppf a; Format.fprintf ppf "%,@,";
    px_a Og_precedence.Ck_tuple_item ppf a0;
    Format.fprintf ppf "%,@;<0 -2></tuple>@]"
;;

let printer_xml_scheme_rec2_lin px_a ctx ppf = function
  | (a, a0) ->
    ignore ctx; Format.fprintf ppf "%,@[<hv 2><tuple>@,";
    px_a Og_precedence.Ck_tuple_item ppf a; Format.fprintf ppf "%,@,";
    px_a Og_precedence.Ck_tuple_item ppf a0;
    Format.fprintf ppf "%,@;<0 -2></tuple>@]"
;;

let printer_xml_prod_scal2 px_a ctx ppf = function
  | f_a_s_f_a_p_a ->
    Og_printer_xml.printer_xml_Fun
      (printer_xml_scheme_rec2_lin px_a)
      (Og_printer_xml.printer_xml_Fun (printer_xml_prev_rec2 px_a) px_a)
      ctx
      ppf
      f_a_s_f_a_p_a
;;

let printer_xml_index_min ctx ppf = function
  | i -> printer_xml_index ctx ppf i

and printer_xml_index_max ctx ppf = function
  | i -> printer_xml_index ctx ppf i
;;

(* Defining top printers. *)

let print_xml_t px_a ppf = printer_xml_t px_a Og_precedence.Ck_toplevel ppf
;;

let print_xml_length ppf = printer_xml_length Og_precedence.Ck_toplevel ppf

and print_xml_index ppf = printer_xml_index Og_precedence.Ck_toplevel ppf

and print_xml_offset ppf = printer_xml_offset Og_precedence.Ck_toplevel ppf
;;

let print_xml_init_rec1 px_a ppf =
  printer_xml_init_rec1 px_a Og_precedence.Ck_toplevel ppf

and print_xml_prev_rec1 px_a ppf =
  printer_xml_prev_rec1 px_a Og_precedence.Ck_toplevel ppf
;;

let print_xml_scheme_rec1_lin px_a ppf =
  printer_xml_scheme_rec1_lin px_a Og_precedence.Ck_toplevel ppf
;;

let print_xml_prod_scal1 px_a ppf =
  printer_xml_prod_scal1 px_a Og_precedence.Ck_toplevel ppf
;;

let print_xml_init_rec2 px_a ppf =
  printer_xml_init_rec2 px_a Og_precedence.Ck_toplevel ppf

and print_xml_prev_rec2 px_a ppf =
  printer_xml_prev_rec2 px_a Og_precedence.Ck_toplevel ppf
;;

let print_xml_scheme_rec2_lin px_a ppf =
  printer_xml_scheme_rec2_lin px_a Og_precedence.Ck_toplevel ppf
;;

let print_xml_prod_scal2 px_a ppf =
  printer_xml_prod_scal2 px_a Og_precedence.Ck_toplevel ppf
;;

let print_xml_index_min ppf =
  printer_xml_index_min Og_precedence.Ck_toplevel ppf

and print_xml_index_max ppf =
  printer_xml_index_max Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.2+dev0 generated code. *)
