(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.2+dev0 generated code. *)

let rec printer_xml_t ctx ppf = function
  | u_b -> Upervasives_print_xml.printer_xml_bytes ctx ppf u_b

and printer_xml_bytes ctx ppf = function | t -> printer_xml_t ctx ppf t
;;

let printer_xml_length ctx ppf = function
  | u_l -> Upervasives_print_xml.printer_xml_length ctx ppf u_l

and printer_xml_index ctx ppf = function
  | u_i -> Upervasives_print_xml.printer_xml_index ctx ppf u_i

and printer_xml_offset ctx ppf = function
  | u_o -> Upervasives_print_xml.printer_xml_offset ctx ppf u_o
;;

let printer_xml_escape_char ctx ppf = function
  | c -> Og_printer_xml.printer_xml_Char ctx ppf c

and printer_xml_escaped_chars ctx ppf = function
  | c_l ->
    Og_printer_xml.printer_xml_List Og_printer_xml.printer_xml_Char
      ctx
      ppf
      c_l
;;

let printer_xml_prefix ctx ppf = function | t -> printer_xml_t ctx ppf t

and printer_xml_suffix ctx ppf = function | t -> printer_xml_t ctx ppf t
;;

(* Defining top printers. *)

let print_xml_t ppf = printer_xml_t Og_precedence.Ck_toplevel ppf

and print_xml_bytes ppf = printer_xml_bytes Og_precedence.Ck_toplevel ppf
;;

let print_xml_length ppf = printer_xml_length Og_precedence.Ck_toplevel ppf

and print_xml_index ppf = printer_xml_index Og_precedence.Ck_toplevel ppf

and print_xml_offset ppf = printer_xml_offset Og_precedence.Ck_toplevel ppf
;;

let print_xml_escape_char ppf =
  printer_xml_escape_char Og_precedence.Ck_toplevel ppf

and print_xml_escaped_chars ppf =
  printer_xml_escaped_chars Og_precedence.Ck_toplevel ppf
;;

let print_xml_prefix ppf = printer_xml_prefix Og_precedence.Ck_toplevel ppf

and print_xml_suffix ppf = printer_xml_suffix Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.2+dev0 generated code. *)
