(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.2+dev0 generated code. *)

let rec printer_xml_print px_a ctx ppf = function
  | f_a_u ->
    Og_printer_xml.printer_xml_Fun px_a Og_printer_xml.printer_xml_Unit
      ctx
      ppf
      f_a_u

and printer_xml_gen_print px_a ctx ppf = function
  | f_u_f_o_a_p ->
    Og_printer_xml.printer_xml_Fun
      (Og_printer_xml.printer_xml_Option
         Upervasives_print_xml.printer_xml_function_name)
      (printer_xml_print px_a)
      ctx
      ppf
      f_u_f_o_a_p
;;

let printer_xml_message_print ctx ppf = function
  | u_m_p ->
    printer_xml_print Upervasives_print_xml.printer_xml_message ctx ppf u_m_p

and printer_xml_gen_message_print ctx ppf = function
  | u_g_p ->
    printer_xml_print Upervasives_print_xml.printer_xml_gen_message
      ctx
      ppf
      u_g_p

and printer_xml_message_gen_print ctx ppf = function
  | u_m_g ->
    printer_xml_gen_print Upervasives_print_xml.printer_xml_message
      ctx
      ppf
      u_m_g

and printer_xml_gen_message_gen_print ctx ppf = function
  | u_g_g ->
    printer_xml_gen_print Upervasives_print_xml.printer_xml_gen_message
      ctx
      ppf
      u_g_g
;;

let printer_xml_printing_facilities ctx ppf = function
  | {
      Udebug.get_warn_error = f_u_b;
      Udebug.report = m;
      Udebug.debug = m0;
      Udebug.warning = m1;
      Udebug.error = m2;
      Udebug.report_action = g;
      Udebug.debug_action = g0;
      Udebug.warning_action = g1;
      Udebug.error_action = g2;
    } ->
    ignore ctx; Format.fprintf ppf "%,@[<hv 2><record>@,";
    Format.fprintf ppf "%,@[<hv 2><get_warn_error>@,";
    Og_printer_xml.printer_xml_Fun
      Og_printer_xml.printer_xml_Unit
      Og_printer_xml.printer_xml_Bool
      Og_precedence.Ck_record_field
      ppf
      f_u_b;
    Format.fprintf ppf "%,@;<0 -2></get_warn_error>@]";
    Format.fprintf ppf "%,@,"; Format.fprintf ppf "%,@[<hv 2><report>@,";
    printer_xml_message_print Og_precedence.Ck_record_field ppf m;
    Format.fprintf ppf "%,@;<0 -2></report>@]"; Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><debug>@,";
    printer_xml_message_gen_print Og_precedence.Ck_record_field ppf m0;
    Format.fprintf ppf "%,@;<0 -2></debug>@]"; Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><warning>@,";
    printer_xml_message_gen_print Og_precedence.Ck_record_field ppf m1;
    Format.fprintf ppf "%,@;<0 -2></warning>@]"; Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><error>@,";
    printer_xml_message_gen_print Og_precedence.Ck_record_field ppf m2;
    Format.fprintf ppf "%,@;<0 -2></error>@]"; Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><report_action>@,";
    printer_xml_gen_message_print Og_precedence.Ck_record_field ppf g;
    Format.fprintf ppf "%,@;<0 -2></report_action>@]";
    Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><debug_action>@,";
    printer_xml_gen_message_gen_print Og_precedence.Ck_record_field ppf g0;
    Format.fprintf ppf "%,@;<0 -2></debug_action>@]";
    Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><warning_action>@,";
    printer_xml_gen_message_gen_print Og_precedence.Ck_record_field ppf g1;
    Format.fprintf ppf "%,@;<0 -2></warning_action>@]";
    Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><error_action>@,";
    printer_xml_gen_message_gen_print Og_precedence.Ck_record_field ppf g2;
    Format.fprintf ppf "%,@;<0 -2></error_action>@]";
    Format.fprintf ppf "%,@;<0 -2></record>@]"
;;

let rec printer_xml_tag ctx ppf = function
  | s -> Og_printer_xml.printer_xml_String ctx ppf s

and printer_xml_make_tag_opt px_a ctx ppf = function
  | f_a_t_o ->
    Og_printer_xml.printer_xml_Fun
      px_a
      (Og_printer_xml.printer_xml_Option printer_xml_tag)
      ctx
      ppf
      f_a_t_o
;;

let printer_xml_dynamic_printing_facilities px_a ctx ppf = function
  | {
      Udebug.dyn_get_warn_error = f_u_b;
      Udebug.dyn_report = f_a_m;
      Udebug.dyn_debug = f_a_m0;
      Udebug.dyn_warning = f_a_m1;
      Udebug.dyn_error = f_a_m2;
      Udebug.dyn_report_action = f_a_g;
      Udebug.dyn_debug_action = f_a_g0;
      Udebug.dyn_warning_action = f_a_g1;
      Udebug.dyn_error_action = f_a_g2;
    } ->
    ignore ctx; Format.fprintf ppf "%,@[<hv 2><record>@,";
    Format.fprintf ppf "%,@[<hv 2><dyn_get_warn_error>@,";
    Og_printer_xml.printer_xml_Fun
      Og_printer_xml.printer_xml_Unit
      Og_printer_xml.printer_xml_Bool
      Og_precedence.Ck_record_field
      ppf
      f_u_b;
    Format.fprintf ppf "%,@;<0 -2></dyn_get_warn_error>@]";
    Format.fprintf ppf "%,@,"; Format.fprintf ppf "%,@[<hv 2><dyn_report>@,";
    Og_printer_xml.printer_xml_Fun px_a printer_xml_message_print
      Og_precedence.Ck_record_field
      ppf
      f_a_m;
    Format.fprintf ppf "%,@;<0 -2></dyn_report>@]";
    Format.fprintf ppf "%,@,"; Format.fprintf ppf "%,@[<hv 2><dyn_debug>@,";
    Og_printer_xml.printer_xml_Fun px_a printer_xml_message_gen_print
      Og_precedence.Ck_record_field
      ppf
      f_a_m0;
    Format.fprintf ppf "%,@;<0 -2></dyn_debug>@]"; Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><dyn_warning>@,";
    Og_printer_xml.printer_xml_Fun px_a printer_xml_message_gen_print
      Og_precedence.Ck_record_field
      ppf
      f_a_m1;
    Format.fprintf ppf "%,@;<0 -2></dyn_warning>@]";
    Format.fprintf ppf "%,@,"; Format.fprintf ppf "%,@[<hv 2><dyn_error>@,";
    Og_printer_xml.printer_xml_Fun px_a printer_xml_message_gen_print
      Og_precedence.Ck_record_field
      ppf
      f_a_m2;
    Format.fprintf ppf "%,@;<0 -2></dyn_error>@]"; Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><dyn_report_action>@,";
    Og_printer_xml.printer_xml_Fun px_a printer_xml_gen_message_print
      Og_precedence.Ck_record_field
      ppf
      f_a_g;
    Format.fprintf ppf "%,@;<0 -2></dyn_report_action>@]";
    Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><dyn_debug_action>@,";
    Og_printer_xml.printer_xml_Fun px_a printer_xml_gen_message_gen_print
      Og_precedence.Ck_record_field
      ppf
      f_a_g0;
    Format.fprintf ppf "%,@;<0 -2></dyn_debug_action>@]";
    Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><dyn_warning_action>@,";
    Og_printer_xml.printer_xml_Fun px_a printer_xml_gen_message_gen_print
      Og_precedence.Ck_record_field
      ppf
      f_a_g1;
    Format.fprintf ppf "%,@;<0 -2></dyn_warning_action>@]";
    Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><dyn_error_action>@,";
    Og_printer_xml.printer_xml_Fun px_a printer_xml_gen_message_gen_print
      Og_precedence.Ck_record_field
      ppf
      f_a_g2;
    Format.fprintf ppf "%,@;<0 -2></dyn_error_action>@]";
    Format.fprintf ppf "%,@;<0 -2></record>@]"
;;

let printer_xml_specialized_printing_facilities ctx ppf = function
  | {
      Udebug.spf_get_warn_error = f_u_b;
      Udebug.spf_report = m;
      Udebug.spf_debug = m0;
      Udebug.spf_warning = m1;
      Udebug.spf_error = m2;
      Udebug.spf_report_action = g;
      Udebug.spf_debug_action = g0;
      Udebug.spf_warning_action = g1;
      Udebug.spf_error_action = g2;
    } ->
    ignore ctx; Format.fprintf ppf "%,@[<hv 2><record>@,";
    Format.fprintf ppf "%,@[<hv 2><spf_get_warn_error>@,";
    Og_printer_xml.printer_xml_Fun
      Og_printer_xml.printer_xml_Unit
      Og_printer_xml.printer_xml_Bool
      Og_precedence.Ck_record_field
      ppf
      f_u_b;
    Format.fprintf ppf "%,@;<0 -2></spf_get_warn_error>@]";
    Format.fprintf ppf "%,@,"; Format.fprintf ppf "%,@[<hv 2><spf_report>@,";
    printer_xml_message_print Og_precedence.Ck_record_field ppf m;
    Format.fprintf ppf "%,@;<0 -2></spf_report>@]";
    Format.fprintf ppf "%,@,"; Format.fprintf ppf "%,@[<hv 2><spf_debug>@,";
    printer_xml_message_print Og_precedence.Ck_record_field ppf m0;
    Format.fprintf ppf "%,@;<0 -2></spf_debug>@]"; Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><spf_warning>@,";
    printer_xml_message_print Og_precedence.Ck_record_field ppf m1;
    Format.fprintf ppf "%,@;<0 -2></spf_warning>@]";
    Format.fprintf ppf "%,@,"; Format.fprintf ppf "%,@[<hv 2><spf_error>@,";
    printer_xml_message_print Og_precedence.Ck_record_field ppf m2;
    Format.fprintf ppf "%,@;<0 -2></spf_error>@]"; Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><spf_report_action>@,";
    printer_xml_gen_message_print Og_precedence.Ck_record_field ppf g;
    Format.fprintf ppf "%,@;<0 -2></spf_report_action>@]";
    Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><spf_debug_action>@,";
    printer_xml_gen_message_print Og_precedence.Ck_record_field ppf g0;
    Format.fprintf ppf "%,@;<0 -2></spf_debug_action>@]";
    Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><spf_warning_action>@,";
    printer_xml_gen_message_print Og_precedence.Ck_record_field ppf g1;
    Format.fprintf ppf "%,@;<0 -2></spf_warning_action>@]";
    Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><spf_error_action>@,";
    printer_xml_gen_message_print Og_precedence.Ck_record_field ppf g2;
    Format.fprintf ppf "%,@;<0 -2></spf_error_action>@]";
    Format.fprintf ppf "%,@;<0 -2></record>@]"
;;

let printer_xml_specialized_dynamic_printing_facilities px_a ctx ppf =
  function
  | {
      Udebug.sdpf_get_warn_error = f_u_b;
      Udebug.sdpf_report = f_a_m;
      Udebug.sdpf_debug = f_a_m0;
      Udebug.sdpf_warning = f_a_m1;
      Udebug.sdpf_error = f_a_m2;
      Udebug.sdpf_report_action = f_a_g;
      Udebug.sdpf_debug_action = f_a_g0;
      Udebug.sdpf_warning_action = f_a_g1;
      Udebug.sdpf_error_action = f_a_g2;
    } ->
    ignore ctx; Format.fprintf ppf "%,@[<hv 2><record>@,";
    Format.fprintf ppf "%,@[<hv 2><sdpf_get_warn_error>@,";
    Og_printer_xml.printer_xml_Fun
      Og_printer_xml.printer_xml_Unit
      Og_printer_xml.printer_xml_Bool
      Og_precedence.Ck_record_field
      ppf
      f_u_b;
    Format.fprintf ppf "%,@;<0 -2></sdpf_get_warn_error>@]";
    Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><sdpf_report>@,";
    Og_printer_xml.printer_xml_Fun px_a printer_xml_message_print
      Og_precedence.Ck_record_field
      ppf
      f_a_m;
    Format.fprintf ppf "%,@;<0 -2></sdpf_report>@]";
    Format.fprintf ppf "%,@,"; Format.fprintf ppf "%,@[<hv 2><sdpf_debug>@,";
    Og_printer_xml.printer_xml_Fun px_a printer_xml_message_print
      Og_precedence.Ck_record_field
      ppf
      f_a_m0;
    Format.fprintf ppf "%,@;<0 -2></sdpf_debug>@]";
    Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><sdpf_warning>@,";
    Og_printer_xml.printer_xml_Fun px_a printer_xml_message_print
      Og_precedence.Ck_record_field
      ppf
      f_a_m1;
    Format.fprintf ppf "%,@;<0 -2></sdpf_warning>@]";
    Format.fprintf ppf "%,@,"; Format.fprintf ppf "%,@[<hv 2><sdpf_error>@,";
    Og_printer_xml.printer_xml_Fun px_a printer_xml_message_print
      Og_precedence.Ck_record_field
      ppf
      f_a_m2;
    Format.fprintf ppf "%,@;<0 -2></sdpf_error>@]";
    Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><sdpf_report_action>@,";
    Og_printer_xml.printer_xml_Fun px_a printer_xml_gen_message_print
      Og_precedence.Ck_record_field
      ppf
      f_a_g;
    Format.fprintf ppf "%,@;<0 -2></sdpf_report_action>@]";
    Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><sdpf_debug_action>@,";
    Og_printer_xml.printer_xml_Fun px_a printer_xml_gen_message_print
      Og_precedence.Ck_record_field
      ppf
      f_a_g0;
    Format.fprintf ppf "%,@;<0 -2></sdpf_debug_action>@]";
    Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><sdpf_warning_action>@,";
    Og_printer_xml.printer_xml_Fun px_a printer_xml_gen_message_print
      Og_precedence.Ck_record_field
      ppf
      f_a_g1;
    Format.fprintf ppf "%,@;<0 -2></sdpf_warning_action>@]";
    Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><sdpf_error_action>@,";
    Og_printer_xml.printer_xml_Fun px_a printer_xml_gen_message_print
      Og_precedence.Ck_record_field
      ppf
      f_a_g2;
    Format.fprintf ppf "%,@;<0 -2></sdpf_error_action>@]";
    Format.fprintf ppf "%,@;<0 -2></record>@]"
;;

(* Defining top printers. *)

let print_xml_print px_a ppf =
  printer_xml_print px_a Og_precedence.Ck_toplevel ppf

and print_xml_gen_print px_a ppf =
  printer_xml_gen_print px_a Og_precedence.Ck_toplevel ppf
;;

let print_xml_message_print ppf =
  printer_xml_message_print Og_precedence.Ck_toplevel ppf

and print_xml_gen_message_print ppf =
  printer_xml_gen_message_print Og_precedence.Ck_toplevel ppf

and print_xml_message_gen_print ppf =
  printer_xml_message_gen_print Og_precedence.Ck_toplevel ppf

and print_xml_gen_message_gen_print ppf =
  printer_xml_gen_message_gen_print Og_precedence.Ck_toplevel ppf
;;

let print_xml_printing_facilities ppf =
  printer_xml_printing_facilities Og_precedence.Ck_toplevel ppf
;;

let print_xml_tag ppf = printer_xml_tag Og_precedence.Ck_toplevel ppf

and print_xml_make_tag_opt px_a ppf =
  printer_xml_make_tag_opt px_a Og_precedence.Ck_toplevel ppf
;;

let print_xml_dynamic_printing_facilities px_a ppf =
  printer_xml_dynamic_printing_facilities px_a Og_precedence.Ck_toplevel ppf
;;

let print_xml_specialized_printing_facilities ppf =
  printer_xml_specialized_printing_facilities Og_precedence.Ck_toplevel ppf
;;

let print_xml_specialized_dynamic_printing_facilities px_a ppf =
  printer_xml_specialized_dynamic_printing_facilities px_a
    Og_precedence.Ck_toplevel
    ppf
;;

(* End of OCamlGen, 4.2+dev0 generated code. *)
