(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.2+dev0 generated code. *)

let printer_xml_arrow_number ctx ppf = function
  | u_a ->
    Udelayed_dgraph_types_print_xml.printer_xml_arrow_number ctx ppf u_a
;;

let printer_xml_delayed_image px_b ctx ppf = function
  | b_u_d ->
    Udelayed_dgraph_types_print_xml.printer_xml_delayed_image px_b
      ctx
      ppf
      b_u_d
;;

let printer_xml_delayed_arrow px_a px_b ctx ppf = function
  | a_b_u_d ->
    Udelayed_dgraph_types_print_xml.printer_xml_delayed_arrow px_a px_b
      ctx
      ppf
      a_b_u_d
;;

let rec printer_xml_t px_a px_b px_c ctx ppf = function
  | a_b_c_u_t ->
    Udelayed_dgraph_types_print_xml.printer_xml_t px_a px_b px_c
      ctx
      ppf
      a_b_c_u_t

and printer_xml_delayed_dgraph px_a px_b px_c ctx ppf = function
  | a_b_c_t -> printer_xml_t px_a px_b px_c ctx ppf a_b_c_t
;;

(* Defining top printers. *)

let print_xml_arrow_number ppf =
  printer_xml_arrow_number Og_precedence.Ck_toplevel ppf
;;

let print_xml_delayed_image px_b ppf =
  printer_xml_delayed_image px_b Og_precedence.Ck_toplevel ppf
;;

let print_xml_delayed_arrow px_a px_b ppf =
  printer_xml_delayed_arrow px_a px_b Og_precedence.Ck_toplevel ppf
;;

let print_xml_t px_a px_b px_c ppf =
  printer_xml_t px_a px_b px_c Og_precedence.Ck_toplevel ppf

and print_xml_delayed_dgraph px_a px_b px_c ppf =
  printer_xml_delayed_dgraph px_a px_b px_c Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.2+dev0 generated code. *)
