(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.2+dev0 generated code. *)

let printer_index pp_a ctx ppf = function
  | a_u_i -> Unonempty_set_print.printer_index pp_a ctx ppf a_u_i

and printer_uindex pp_a ctx ppf = function
  | a_u_u -> Unonempty_set_print.printer_uindex pp_a ctx ppf a_u_u
;;

let printer_domain pp_a ctx ppf = function
  | a_u_t -> Unonempty_set_print.printer_t pp_a ctx ppf a_u_t
;;

let printer_images pp_b ctx ppf = function
  | Ugraph_types.Constant b ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Constant";
    pp_b Og_precedence.Ck_argument ppf b; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Ugraph_types.Images b_a ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Images";
    Og_printer.printer_Array pp_b Og_precedence.Ck_argument ppf b_a;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let rec printer_t pp_a pp_b ctx ppf = function
  | { Ugraph_types.domain = a_d; Ugraph_types.images = b_i; } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,@[<hv 2>domain =";
    printer_domain pp_a Og_precedence.Ck_record_field ppf a_d;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>images =";
    printer_images pp_b Og_precedence.Ck_record_field ppf b_i;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_graph pp_a pp_b ctx ppf = function
  | a_b_t -> printer_t pp_a pp_b ctx ppf a_b_t
;;

(* Defining top printers. *)

let print_index pp_a ppf = printer_index pp_a Og_precedence.Ck_toplevel ppf

and print_uindex pp_a ppf = printer_uindex pp_a Og_precedence.Ck_toplevel ppf
;;

let print_domain pp_a ppf = printer_domain pp_a Og_precedence.Ck_toplevel ppf
;;

let print_images pp_b ppf = printer_images pp_b Og_precedence.Ck_toplevel ppf
;;

let print_t pp_a pp_b ppf = printer_t pp_a pp_b Og_precedence.Ck_toplevel ppf

and print_graph pp_a pp_b ppf =
  printer_graph pp_a pp_b Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.2+dev0 generated code. *)
