(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.2+dev0 generated code. *)

let rec printer_xml_t ctx ppf = function
  | u_t -> Uoption_key_types_print_xml.printer_xml_t ctx ppf u_t

and printer_xml_option_key ctx ppf = function | t -> printer_xml_t ctx ppf t
;;

let rec printer_xml_long_option_key ctx ppf = function
  | t -> printer_xml_t ctx ppf t

and printer_xml_short_option_key ctx ppf = function
  | t -> printer_xml_t ctx ppf t

and printer_xml_short_option_key_status ctx ppf = function
  | Uoption_key.Automatic ->
    ignore ctx; Format.fprintf ppf "%,@[<hv 2><constructor>@,";
    Format.fprintf ppf "%,@[<hv 2><lident>@,";
    Format.fprintf ppf "%,Automatic";
    Format.fprintf ppf "%,@;<0 -2></lident>@]";
    Format.fprintf ppf "%,@;<0 -2></constructor>@]"
  | Uoption_key.Short s ->
    ignore ctx; Format.fprintf ppf "%,@[<hv 2><constructor>@,";
    Format.fprintf ppf "%,@[<hv 2><lident>@,"; Format.fprintf ppf "%,Short";
    Format.fprintf ppf "%,@;<0 -2></lident>@]"; Format.fprintf ppf "%,@,";
    printer_xml_short_option_key Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@;<0 -2></constructor>@]"

and printer_xml_option_keys ctx ppf = function
  | { Uoption_key.long = l; Uoption_key.short = s; } ->
    ignore ctx; Format.fprintf ppf "%,@[<hv 2><record>@,";
    Format.fprintf ppf "%,@[<hv 2><long>@,";
    printer_xml_long_option_key Og_precedence.Ck_record_field ppf l;
    Format.fprintf ppf "%,@;<0 -2></long>@]"; Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><short>@,";
    printer_xml_short_option_key_status Og_precedence.Ck_record_field ppf s;
    Format.fprintf ppf "%,@;<0 -2></short>@]";
    Format.fprintf ppf "%,@;<0 -2></record>@]"
;;

(* Defining top printers. *)

let print_xml_t ppf = printer_xml_t Og_precedence.Ck_toplevel ppf

and print_xml_option_key ppf =
  printer_xml_option_key Og_precedence.Ck_toplevel ppf
;;

let print_xml_long_option_key ppf =
  printer_xml_long_option_key Og_precedence.Ck_toplevel ppf

and print_xml_short_option_key ppf =
  printer_xml_short_option_key Og_precedence.Ck_toplevel ppf

and print_xml_short_option_key_status ppf =
  printer_xml_short_option_key_status Og_precedence.Ck_toplevel ppf

and print_xml_option_keys ppf =
  printer_xml_option_keys Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.2+dev0 generated code. *)
