(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.2+dev0 generated code. *)

let printer_xml_bytes ctx ppf = function
  | u_b -> Upervasives_types_print_xml.printer_xml_bytes ctx ppf u_b
;;

let rec printer_xml_software_name ctx ppf = function
  | s -> Og_printer_xml.printer_xml_String ctx ppf s

and printer_xml_module_name ctx ppf = function
  | s -> Og_printer_xml.printer_xml_String ctx ppf s

and printer_xml_function_name ctx ppf = function
  | s -> Og_printer_xml.printer_xml_String ctx ppf s

and printer_xml_tag ctx ppf = function
  | s -> Og_printer_xml.printer_xml_String ctx ppf s

and printer_xml_prefix ctx ppf = function
  | s -> Og_printer_xml.printer_xml_String ctx ppf s

and printer_xml_message ctx ppf = function
  | s -> Og_printer_xml.printer_xml_String ctx ppf s

and printer_xml_gen_message ctx ppf = function
  | f_u_m ->
    Og_printer_xml.printer_xml_Fun
      Og_printer_xml.printer_xml_Unit
      printer_xml_message
      ctx
      ppf
      f_u_m

and printer_xml_qualify ctx ppf = function
  | f_f_f ->
    Og_printer_xml.printer_xml_Fun
      printer_xml_function_name
      printer_xml_function_name
      ctx
      ppf
      f_f_f
;;

let printer_xml_length ctx ppf = function
  | u_t -> Unatural_print_xml.printer_xml_t ctx ppf u_t
;;

let printer_xml_index ctx ppf = function
  | u_t -> Unatural_print_xml.printer_xml_t ctx ppf u_t
;;

let printer_xml_offset ctx ppf = function
  | u_t -> Unatural_print_xml.printer_xml_t ctx ppf u_t
;;

let printer_xml_select _ctx ppf = function
  | Upervasives.Keep ->
    ignore _ctx; Format.fprintf ppf "%,@[<hv 2><constructor>@,";
    Format.fprintf ppf "%,@[<hv 2><lident>@,"; Format.fprintf ppf "%,Keep";
    Format.fprintf ppf "%,@;<0 -2></lident>@]";
    Format.fprintf ppf "%,@;<0 -2></constructor>@]"
  | Upervasives.Forget ->
    ignore _ctx; Format.fprintf ppf "%,@[<hv 2><constructor>@,";
    Format.fprintf ppf "%,@[<hv 2><lident>@,"; Format.fprintf ppf "%,Forget";
    Format.fprintf ppf "%,@;<0 -2></lident>@]";
    Format.fprintf ppf "%,@;<0 -2></constructor>@]"
;;

let printer_xml_gen_message_option ctx ppf = function
  | f_u_m_o ->
    Og_printer_xml.printer_xml_Fun
      Og_printer_xml.printer_xml_Unit
      (Og_printer_xml.printer_xml_Option printer_xml_message)
      ctx
      ppf
      f_u_m_o

and printer_xml_qualify_opt ctx ppf = function
  | f_f_o_f_o ->
    Og_printer_xml.printer_xml_Fun
      (Og_printer_xml.printer_xml_Option printer_xml_function_name)
      (Og_printer_xml.printer_xml_Option printer_xml_function_name)
      ctx
      ppf
      f_f_o_f_o
;;

(* Defining top printers. *)

let print_xml_bytes ppf = printer_xml_bytes Og_precedence.Ck_toplevel ppf
;;

let print_xml_software_name ppf =
  printer_xml_software_name Og_precedence.Ck_toplevel ppf

and print_xml_module_name ppf =
  printer_xml_module_name Og_precedence.Ck_toplevel ppf

and print_xml_function_name ppf =
  printer_xml_function_name Og_precedence.Ck_toplevel ppf

and print_xml_tag ppf = printer_xml_tag Og_precedence.Ck_toplevel ppf

and print_xml_prefix ppf = printer_xml_prefix Og_precedence.Ck_toplevel ppf

and print_xml_message ppf = printer_xml_message Og_precedence.Ck_toplevel ppf

and print_xml_gen_message ppf =
  printer_xml_gen_message Og_precedence.Ck_toplevel ppf

and print_xml_qualify ppf = printer_xml_qualify Og_precedence.Ck_toplevel ppf
;;

let print_xml_length ppf = printer_xml_length Og_precedence.Ck_toplevel ppf
;;

let print_xml_index ppf = printer_xml_index Og_precedence.Ck_toplevel ppf
;;

let print_xml_offset ppf = printer_xml_offset Og_precedence.Ck_toplevel ppf
;;

let print_xml_select ppf = printer_xml_select Og_precedence.Ck_toplevel ppf
;;

let print_xml_gen_message_option ppf =
  printer_xml_gen_message_option Og_precedence.Ck_toplevel ppf

and print_xml_qualify_opt ppf =
  printer_xml_qualify_opt Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.2+dev0 generated code. *)
