(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.2+dev0 generated code. *)

let rec printer_t ctx ppf = function
  | {
      Upph_id_card.project_name = s;
      Upph_id_card.project_banner_title = s0;
      Upph_id_card.project_outline = s1;
      Upph_id_card.project_release_date = s2;
      Upph_id_card.project_copyright_holders = s3;
      Upph_id_card.project_authors = s4;
      Upph_id_card.project_http_url = s5;
      Upph_id_card.project_ftp_url = s6;
      Upph_id_card.project_release_ident = s7;
      Upph_id_card.project_distribution_ident = s8;
      Upph_id_card.project_version = s9;
      Upph_id_card.project_version_full_info = s10;
      Upph_id_card.project_release_name = s11;
      Upph_id_card.project_distribution_name = s12;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,@[<hv 2>project_name =";
    Og_printer.printer_String Og_precedence.Ck_record_field ppf s;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>project_banner_title =";
    Og_printer.printer_String Og_precedence.Ck_record_field ppf s0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>project_outline =";
    Og_printer.printer_String Og_precedence.Ck_record_field ppf s1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>project_release_date =";
    Og_printer.printer_String Og_precedence.Ck_record_field ppf s2;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>project_copyright_holders =";
    Og_printer.printer_String Og_precedence.Ck_record_field ppf s3;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>project_authors =";
    Og_printer.printer_String Og_precedence.Ck_record_field ppf s4;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>project_http_url =";
    Og_printer.printer_String Og_precedence.Ck_record_field ppf s5;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>project_ftp_url =";
    Og_printer.printer_String Og_precedence.Ck_record_field ppf s6;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>project_release_ident =";
    Og_printer.printer_String Og_precedence.Ck_record_field ppf s7;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>project_distribution_ident =";
    Og_printer.printer_String Og_precedence.Ck_record_field ppf s8;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>project_version =";
    Og_printer.printer_String Og_precedence.Ck_record_field ppf s9;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>project_version_full_info =";
    Og_printer.printer_String Og_precedence.Ck_record_field ppf s10;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>project_release_name =";
    Og_printer.printer_String Og_precedence.Ck_record_field ppf s11;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>project_distribution_name =";
    Og_printer.printer_String Og_precedence.Ck_record_field ppf s12;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_pph_id_card ctx ppf = function | t -> printer_t ctx ppf t
;;

(* Defining top printers. *)

let print_t ppf = printer_t Og_precedence.Ck_toplevel ppf

and print_pph_id_card ppf = printer_pph_id_card Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.2+dev0 generated code. *)
