(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.2+dev0 generated code. *)

let printer_index ctx ppf = function
  | u_i -> Udynamic_array_print.printer_index ctx ppf u_i
;;

let printer_length ctx ppf = function
  | u_l -> Udynamic_array_print.printer_length ctx ppf u_l
;;

let printer_stamped pp_a ctx ppf = function
  | Ustamped_darray.Unset ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Unset"
  | Ustamped_darray.Valid a ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Valid";
    pp_a Og_precedence.Ck_argument ppf a; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let rec printer_t pp_a ctx ppf = function
  | { Ustamped_darray.darray = a_s_u_t; Ustamped_darray.next_unset = i; } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,@[<hv 2>darray =";
    Udynamic_array_print.printer_t (printer_stamped pp_a)
      Og_precedence.Ck_record_field
      ppf
      a_s_u_t;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>next_unset =";
    printer_index Og_precedence.Ck_record_field ppf i;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_stamped_darray pp_a ctx ppf = function
  | a_t -> printer_t pp_a ctx ppf a_t
;;

(* Defining top printers. *)

let print_index ppf = printer_index Og_precedence.Ck_toplevel ppf
;;

let print_length ppf = printer_length Og_precedence.Ck_toplevel ppf
;;

let print_stamped pp_a ppf =
  printer_stamped pp_a Og_precedence.Ck_toplevel ppf
;;

let print_t pp_a ppf = printer_t pp_a Og_precedence.Ck_toplevel ppf

and print_stamped_darray pp_a ppf =
  printer_stamped_darray pp_a Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.2+dev0 generated code. *)
