(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2016 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.1+dev0 generated code. *)

let rec printer_t _pp_a ctx ppf = function
  | d_t -> Digest_print.printer_t ctx ppf d_t

and printer_type_digest pp_a ctx ppf = function
  | a_t -> printer_t pp_a ctx ppf a_t
;;

let printer_lifter pp_a pp_b ctx ppf = function
  | f_a_t_b_t ->
    Og_printer.printer_Fun (printer_t pp_a) (printer_t pp_b)
      ctx
      ppf
      f_a_t_b_t
;;

let printer_lifter2 pp_a pp_b pp_c ctx ppf = function
  | f_a_t_f_b_t_c_t ->
    Og_printer.printer_Fun
      (printer_t pp_a)
      (Og_printer.printer_Fun (printer_t pp_b) (printer_t pp_c))
      ctx
      ppf
      f_a_t_f_b_t_c_t
;;

let printer_lifter3 pp_a pp_b pp_c pp_d ctx ppf = function
  | f_a_t_f_b_t_f_c_t_d_t ->
    Og_printer.printer_Fun
      (printer_t pp_a)
      (Og_printer.printer_Fun
         (printer_t pp_b)
         (Og_printer.printer_Fun (printer_t pp_c) (printer_t pp_d)))
      ctx
      ppf
      f_a_t_f_b_t_f_c_t_d_t
;;

let printer_lifter4 pp_a pp_b pp_c pp_d pp_e ctx ppf = function
  | f_a_t_f_b_t_f_c_t_f_d_t_e_t ->
    Og_printer.printer_Fun
      (printer_t pp_a)
      (Og_printer.printer_Fun
         (printer_t pp_b)
         (Og_printer.printer_Fun
            (printer_t pp_c)
            (Og_printer.printer_Fun (printer_t pp_d) (printer_t pp_e))))
      ctx
      ppf
      f_a_t_f_b_t_f_c_t_f_d_t_e_t
;;

let printer_lifter6 pp_a pp_b pp_c pp_d pp_e pp_f pp_g ctx ppf = function
  | f_a_t_f_b_t_f_c_t_f_d_t_f_e_t_f_f_t_g_t ->
    Og_printer.printer_Fun
      (printer_t pp_a)
      (Og_printer.printer_Fun
         (printer_t pp_b)
         (Og_printer.printer_Fun
            (printer_t pp_c)
            (Og_printer.printer_Fun
               (printer_t pp_d)
               (Og_printer.printer_Fun
                  (printer_t pp_e)
                  (Og_printer.printer_Fun (printer_t pp_f) (printer_t pp_g))))))
      ctx
      ppf
      f_a_t_f_b_t_f_c_t_f_d_t_f_e_t_f_f_t_g_t
;;

let printer_type_name ctx ppf = function
  | s -> Og_printer.printer_String ctx ppf s
;;

(* Defining top printers. *)

let print_t pp_a ppf = printer_t pp_a Og_precedence.Ck_toplevel ppf

and print_type_digest pp_a ppf =
  printer_type_digest pp_a Og_precedence.Ck_toplevel ppf
;;

let print_lifter pp_a pp_b ppf =
  printer_lifter pp_a pp_b Og_precedence.Ck_toplevel ppf
;;

let print_lifter2 pp_a pp_b pp_c ppf =
  printer_lifter2 pp_a pp_b pp_c Og_precedence.Ck_toplevel ppf
;;

let print_lifter3 pp_a pp_b pp_c pp_d ppf =
  printer_lifter3 pp_a pp_b pp_c pp_d Og_precedence.Ck_toplevel ppf
;;

let print_lifter4 pp_a pp_b pp_c pp_d pp_e ppf =
  printer_lifter4 pp_a pp_b pp_c pp_d pp_e Og_precedence.Ck_toplevel ppf
;;

let print_lifter6 pp_a pp_b pp_c pp_d pp_e pp_f pp_g ppf =
  printer_lifter6 pp_a pp_b pp_c pp_d pp_e pp_f pp_g
    Og_precedence.Ck_toplevel
    ppf
;;

let print_type_name ppf = printer_type_name Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.1+dev0 generated code. *)
