(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.2+dev0 generated code. *)

let printer_index pp_a ctx ppf = function
  | a_u_t -> Uindex_print.printer_t pp_a ctx ppf a_u_t
;;

let printer_indices _pp_a ctx ppf = function
  | a -> Og_printer.printer_Abstract ctx ppf a
;;

let printer_elements pp_a ctx ppf = function
  | a_a -> Og_printer.printer_Array pp_a ctx ppf a_a
;;

let rec printer_t pp_a ctx ppf = function
  | {
      Uuniverse_types.indices = a_i;
      Uuniverse_types.elements = a_e;
      Uuniverse_types.cardinal = u_t;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,@[<hv 2>indices =";
    printer_indices pp_a Og_precedence.Ck_record_field ppf a_i;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>elements =";
    printer_elements pp_a Og_precedence.Ck_record_field ppf a_e;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>cardinal =";
    Unatural_print.printer_t Og_precedence.Ck_record_field ppf u_t;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_universe pp_a ctx ppf = function
  | a_t -> printer_t pp_a ctx ppf a_t
;;

(* Defining top printers. *)

let print_index pp_a ppf = printer_index pp_a Og_precedence.Ck_toplevel ppf
;;

let print_indices pp_a ppf =
  printer_indices pp_a Og_precedence.Ck_toplevel ppf
;;

let print_elements pp_a ppf =
  printer_elements pp_a Og_precedence.Ck_toplevel ppf
;;

let print_t pp_a ppf = printer_t pp_a Og_precedence.Ck_toplevel ppf

and print_universe pp_a ppf =
  printer_universe pp_a Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.2+dev0 generated code. *)
