(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: ufilename.mli,v 1.13 2017/05/31 15:24:06 fclement Exp $ *)

(** {3 More filename operations} *)

type t = string
and filename = t
(** The type for filenames. It is an alias for type [string]. *)
;;

val flatten : t list -> t;;

val chop_extension : t -> t
(** [chop_extension name] returns [name] without its extension, or unchanged
   if no extension is found.
   The extension is the shortest suffix starting with a period and not
   including a directory separator.  *)
;;
