(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: uindex.mli,v 1.10 2017/05/31 15:24:06 fclement Exp $*)

(** {3 The phantom type of indices} *)

type 'a t = private Unatural.t
and 'a index = 'a t
;;

external to_t : Unatural.t -> 'a t = "%identity";;
external of_t : 'a t -> Unatural.t = "%identity";;

external of_nat : Unatural.t -> 'a t = "%identity";;
external to_nat : 'a t -> Unatural.t = "%identity";;

val of_int : int -> 'a t;;
external to_int : 'a t -> int = "%identity";;

val _0_ : 'a t;;
val _1_ : 'a t;;

val succ : 'a t -> 'a t;;
val pred : 'a t -> 'a t;;

val incr : 'a t ref -> unit;;
val decr : 'a t ref -> unit;;
